import numpy as np
import pandas as pd
import lqmtest_x3_5_pool
import lqmtest_x3_2_load_data
import lqmtest_x3_4_conv_proc
import lqmtest_x3_6_fullconn
import lqmtest_x3_7_nonlinear
import lqmtest_x3_8_classify
class Label:  #  标签
    # 设置标签类别列表并将其转化为one-hot向量的形式
    def setlabel_para(self):
        label_list = input("请输入标签类别列表（用逗号分隔）：")
        label_list = [int(x) for x in label_list.split(',')]
        num_classes = len(label_list)
        identity_matrix = np.eye(num_classes)
        label_dict = {label: identity_matrix[i] for
                      i, label in enumerate(label_list)}
        return label_dict
    # 读取样本数据集，遍历每个样本，并将样本和对应的标签组成元组
    def label_proc(self, samples, labels, label_dict):
        labeled_samples = [(sample, label_dict[label]) for
                        sample, label in zip(samples, labels)]
        return labeled_samples
    def label_array(self, i):
        path_csv = 'train.csv' # 读取标签数据
        df = pd.read_csv(path_csv, header=None, skiprows=range(0,
                            i * 32), nrows=(i + 1) * 32 - i * 32)
        # 将标签数据转化成数组
        right_label = df.iloc[:, 0].tolist()
        right_label = list(map(int, right_label))
        right_label = [x for x in right_label]
        return right_label
if __name__ == '__main__':
    DataSet = lqmtest_x3_2_load_data.Data_Class("DataSet1", 1, "数据集1", [], 120, 330)
    # setload_data()函数，获取加载数据集的参数
    DataPara = DataSet.SetDataPara()
    train_images, test_images = DataSet.LoadData(DataPara)

    Conv = lqmtest_x3_4_conv_proc.Conv_Class("Conv1", 2, "卷积1", [], 250, 330)
    ConvPara = Conv.SetConvPara()
    for i in range(len(train_images) // 32):
        images = train_images[i * 32:(i + 1) * 32]
        conv_images = []  # 存储卷积处理后的图片的列表
        for image in images:  # 获取训练集的图片数据
            dim = len(image.shape)  # 获取矩阵的维度
            if dim == 2:  # 如果是二维矩阵,则转化为三维矩阵
                image_h, image_w = image.shape
                image = np.reshape(image, (1, image_h, image_w))
                # 调用ConvProc()函数，根据ConvPara参数完成卷积计算
                output = Conv.ConvProc(image, ConvPara)
                conv_images.append(output)  # 将卷积结果存储到列表
            elif dim == 3:  # 若为三维矩阵，则保持不变直接卷积处理
                output = Conv.ConvProc(image, ConvPara)
                conv_images.append(output)
        # 将卷积处理后的图片列表转换为数组形式，方便后续处理
        conv_images = np.array(conv_images)
    
    Pool = lqmtest_x3_5_pool.Pool_Class("Pool1", 3, "最大池化1", [], 380, 330)
    PoolPara = Pool.SetPollPara()
    pool_images = []  # 存储池化处理后的图片的列表
    for image in conv_images:  # 获取卷积后的图片数据
        output = Pool.MaxPoolProc(image, PoolPara)
        pool_images.append(output)  # 将池化结果存储到列表
    # 将池化处理后的图片列表转换为数组形式，方便后续处理
    pool_images = np.array(pool_images)
    
    _, _, poolH, poolW = pool_images.shape
    FullConn = lqmtest_x3_6_fullconn.FullConn_Class("FullConn1", 4, "全连接1", [], 510, 330)
    FullConnPara = FullConn.SetFullConnPara(poolH, poolW)
    
    fullconn_images = []      # 存储全连接处理后的图片的列表
    for image in pool_images: # 获取池化后的图片数据
        output = FullConn.FullConnProc(image, FullConnPara)
        fullconn_images.append(output)  # 将全连接处理后的结果存储到列表
    # 将全连接处理后的图片列表转换为数组形式，方便后续处理
    fullconn_images = np.array(fullconn_images)
    
    Nonline = lqmtest_x3_7_nonlinear.Nonline_Class("Nonline1", 5, "非线性函数1", [], 640, 330)
    NonLPara = Nonline.SetNonLPara()
    # 存储非线性处理后的图片的列表
    nonlinear_images = []
    for image in fullconn_images:  # 获取全连接处理后的图片数据
        output = Nonline.NonlinearProc(image, NonLPara)
        # 将非线性处理后的结果存储到列表
        nonlinear_images.append(output)
    # 将非线性处理后的图片列表转换为数组形式，方便后续处理
    nonlinear_images = np.array(nonlinear_images)
    
    Classifier=lqmtest_x3_8_classify.Classifier_Class("Classifier1", 6, "分类1", [], 780, 330)
    ClassifyPara = Classifier.SetClassifyPara()
    classifier_images = []  # 存储分类处理后的图片的列表
    prob_images = []  # 存储分类处理后的概率向量
    for image in nonlinear_images:  # 获取非线性处理后的图片数据
        # 调用softmax函数，得到概率分布向量
        prob = Classifier.softmax(image)
        prob_images.append(prob)  # 将概率向量结果存储到列表
        output = Classifier.ClassifierProc(image, ClassifyPara)
        classifier_images.append(output)  # 将分类结果存储到列表
    # 将分类的结果列表转换为数组形式，方便后续处理
    classifier_images = np.array(classifier_images)
    
    LabelPara = Label()
    label_dict = LabelPara.setlabel_para()
    right_label = LabelPara.label_array(i)
    labeled_samples = LabelPara.label_proc(images,
                                        right_label, label_dict)